package FmModel;

// Read 'FmModel/State.java' for documentation.
//

public class Operators extends Model.Operators
{

  public Model.State Nil()
  { return new State(new NilTerm());
  }


  public Model.State Fus(String a,String b)
  { FusTerm t = new FusTerm(new Name(a),new Name(b));
    return new State(t);
  }

  public Model.State Par(Model.State ssa,Model.State ssb) throws Exception
  { State sa=(State)ssa, sb=(State)ssb;
    if (!sa.isnascent || !sb.isnascent) throw new Exception("Cannot compose a reacted machine");
    Term t = new ParTerm(sa.term,sb.term);
    return new State(t);
  }
  
  public Model.State Sum(Model.State ssa,Model.State ssb) throws Exception
  { throw new Exception("Sum not implemented in fusion machine"); 
  }


  public Model.State Res(String[] rs,Model.State ss) throws Exception
  { State s = (State)ss;
    if (!s.isnascent) throw new Exception("Cannot compose a reacted machine");
    Term t = s.term;
    for (int i=rs.length-1; i>=0; i--) {t=new ResTerm(new Name(rs[i]),t);}
    return new State(t);
  }


  public Model.State Rep(Model.State ss) throws Exception
  { State s = (State)ss;
    if (!s.isnascent) throw new Exception("Cannot compose a reacted machine");
    XmitTerm t = (XmitTerm)s.term;
    if (t==null || t.isrep) throw new Exception("Can only replicate input and output commands");
    t.isrep=true;
    return s;
  }

  public Model.State Snd(String n,String[] dat,boolean isbound,Model.State P) throws Exception
  { State s = (State)P;
    if (!s.isnascent) throw new Exception("Cannot compose a reacted machine");
    XmitTerm t = new XmitTerm();
    t.isrep = false;
    t.chan = new NameOrChannelid(new Name(n));
    t.issend = true;
    for (int i=0; i<dat.length; i++) t.dat.addElement(new NameOrChannelid(new Name(dat[i])));
    t.isbound = isbound;
    t.P = s.term;
    return new State(t);
  }

  public Model.State Rcv(String n,String[] dat,boolean isbound,Model.State P) throws Exception
  { State s = (State)P;
    if (!s.isnascent) throw new Exception("Cannot compose a reacted machine");
    XmitTerm t = new XmitTerm();
    t.isrep = false;
    t.chan = new NameOrChannelid(new Name(n));
    t.issend = false;
    for (int i=0; i<dat.length; i++) t.dat.addElement(new NameOrChannelid(new Name(dat[i])));
    t.isbound = isbound;
    t.P = s.term;
    return new State(t);
  }

}
