/* Generated By:JavaCC: Do not edit this line. Token.java Version 2.1 */
// This is a grammar, to be compiled with JavaCC.
// It translates from a text string into the pi calculus. The
// pi calculus is represented as an abstract model, solely through
// its operators (Model.Operators ops). That means that when we
// parse the text string "u<x> | u(y)" we will return the
// value ops.Par(ops.Send("u","x"), ops.Rcv("u","y")).
//
// As for the grammar itself:
//  P ::= Loose
//
//  Loose ::= Middle | Middle | ...
//    (A 'loose' is a collection of terms in parallel. It's called 'loose'
//     because parallel composition | binds least tightly.)
//
//  Middle ::= Tight + Tight + ...
//    (Summation binds a bit more tightly. So, "A+B|C" is really (A+B)|C )
//
//  Tight ::= (Loose)
//            (x..)P
//            !Tight
//            0 or Nil
//            x=y
//            Xmit
//    (Actually, here we have an issue. When you first read the ( symbol,
//     you don't know if it will start a restriction or just a parenthetical grouping.
//     We need to look ahead a little. If it is a parenthetical grouping, then
//     the Loose inside must start with (, !, 0, nil, x=, x!, x?, x< or x(.
//     So if we find ( follows by one of those, then we know it's a loose.
//     Any other ( we find must necessarily be a restriction. Yuck! 
//     Another issue is that when we read 0, it might either be a
//     nil or it might be part of a fusion 0=x, so we have to lookahead
//     for the equals sign. These all feel like horrible hacks! But I'm
//     not good enough with grammars to find a better way.)
//
// Xmit ::= u!dats [.Tight]
//          u?dats [.Tight]
//          u<dats> [.Tight]
//          u(dats) [.Tight]


package TextModel;

/**
 * Describes the input token stream.
 */

public class Token {

  /**
   * An integer that describes the kind of this token.  This numbering
   * system is determined by JavaCCParser, and a table of these numbers is
   * stored in the file ...Constants.java.
   */
  public int kind;

  /**
   * beginLine and beginColumn describe the position of the first character
   * of this token; endLine and endColumn describe the position of the
   * last character of this token.
   */
  public int beginLine, beginColumn, endLine, endColumn;

  /**
   * The string image of the token.
   */
  public String image;

  /**
   * A reference to the next regular (non-special) token from the input
   * stream.  If this is the last token from the input stream, or if the
   * token manager has not read tokens beyond this one, this field is
   * set to null.  This is true only if this token is also a regular
   * token.  Otherwise, see below for a description of the contents of
   * this field.
   */
  public Token next;

  /**
   * This field is used to access special tokens that occur prior to this
   * token, but after the immediately preceding regular (non-special) token.
   * If there are no such special tokens, this field is set to null.
   * When there are more than one such special token, this field refers
   * to the last of these special tokens, which in turn refers to the next
   * previous special token through its specialToken field, and so on
   * until the first special token (whose specialToken field is null).
   * The next fields of special tokens refer to other special tokens that
   * immediately follow it (without an intervening regular token).  If there
   * is no such token, this field is null.
   */
  public Token specialToken;

  /**
   * Returns the image.
   */
  public final String toString()
  {
     return image;
  }

  /**
   * Returns a new Token object, by default. However, if you want, you
   * can create and return subclass objects based on the value of ofKind.
   * Simply add the cases to the switch for all those special cases.
   * For example, if you have a subclass of Token called IDToken that
   * you want to create if ofKind is ID, simlpy add something like :
   *
   *    case MyParserConstants.ID : return new IDToken();
   *
   * to the following switch statement. Then you can cast matchedToken
   * variable to the appropriate type and use it in your lexical actions.
   */
  public static final Token newToken(int ofKind)
  {
     switch(ofKind)
     {
       default : return new Token();
     }
  }

}
