package Ptrs;


public class State extends Model.State
{ Names names=new Names(); Reps reps=new Reps(); Sums sums=new Sums();
  Name[] dats=new Name[0];
  String[] frees=new String[0]; Name[] freen=new Name[0]; // the free names are stored in alphabetical order

  public String toString()
  { EnsureNamesUnique();
    String s="";
    for (int ni=0; ni<names.size(); ni++) s=s+names.nameAt(ni).toString()+" ";
    s=s+"<"; for (int i=0; i<dats.length; i++) {if (i!=0) s=s+","; s=s+dats[i].title;} s=s+"> ";
    s=s+"\""; for (int i=0; i<frees.length; i++) {if (i!=0) s=s+","; s=s+freen[i].title;} s=s+"\"";
    return s;
  }
  
  
  public void Step(Object o) throws Exception
  { Step step=(Step)o; if (step==null) throw new Exception("Invalid step");
    if (step.type==1) StepMove(step.xmit1,step.name1,step.name2);
    else if (step.type==2) StepGc(step.name1);
    else if (step.type==3) StepInteract(step.xmit1,step.xmit2,step.name1);
    else if (step.type==4) StepMoveFree(step.i,step.name1,step.name2);
    else if (step.type==5) StepMoveDat(step.i,step.name1,step.name2);
    else throw new Exception("Invalid step type");
    StepRemoveFrees();
  }

  public void StepRemoveFrees()
  { RNames toremove=new RNames();
    for (int i=0; i<freen.length; i++)
    { Name n=freen[i];
      boolean hasatoms = (n.snds.size()>0 || n.rcvs.size()>0 || n.snds_dormant.size()>0 || n.rcvs_dormant.size()>0);
      if (n.nref==1 && !hasatoms && n.fusion==null) toremove.addElement(n);
    }
    if (toremove.size()==0) return;
    String[] fs=new String[frees.length-toremove.size()]; Name[] fn=new Name[freen.length-toremove.size()]; int c=0;
    for (int i=0; i<freen.length; i++) {if (!toremove.contains(freen[i])) {fs[c]=frees[i]; fn[c]=freen[i]; c++;}}
    freen=fn; frees=fs;
    for (int i=0; i<toremove.size(); i++)
    { Name n=toremove.nameAt(i); n.nref=0; names.removeElement(n);
    }
  }



  public void StepMove(Xmit xmit,Name nsrc,Name ndst) throws Exception
  { if (nsrc.snds.contains(xmit)) {nsrc.snds.removeElement(xmit); ndst.snds.addElement(xmit);}
    else if (nsrc.rcvs.contains(xmit)) {nsrc.rcvs.removeElement(xmit); ndst.rcvs.addElement(xmit);}
    else if (nsrc.snds_dormant.contains(xmit)) {nsrc.snds_dormant.removeElement(xmit); ndst.snds_dormant.addElement(xmit);}
    else if (nsrc.rcvs_dormant.contains(xmit)) {nsrc.rcvs_dormant.removeElement(xmit); ndst.rcvs_dormant.addElement(xmit);}
    else throw new Exception("Asked to move an xmit, but it wasn't there!");
  }

  public void StepMoveFree(int i,Name nsrc,Name ndst) throws Exception
  { freen[i]=ndst; nsrc.nref--; ndst.nref++;
  }

  public void StepMoveDat(int i,Name nsrc,Name ndst) throws Exception
  { dats[i]=ndst; nsrc.nref--; ndst.nref++;
  }

  // Garbage collection will only happen if the name has no infusions, datums, frees
  // or replications coming into it. (actually, we should allow repl., but won't)
  // It may have xmits (in which case destroy them)
  // The xmits may be part of a sum (in which case remove only this branch of the sum)
  // The xmits may be replicated (in which case remove this from the replication)
  // The xmits may activate other xmits (in which case, destroy those other xmits as well)
  public void StepGc(Name n) throws Exception
  { names.removeElement(n);
    if (n.fusion!=null) n.fusion.nref--;
    for (int i=0; i<n.snds.size(); i++) StepGcXmit(n.snds.xmitAt(i));
    for (int i=0; i<n.rcvs.size(); i++) StepGcXmit(n.rcvs.xmitAt(i));
    for (int i=0; i<n.snds_dormant.size(); i++) StepGcXmit(n.snds_dormant.xmitAt(i));
    for (int i=0; i<n.rcvs_dormant.size(); i++) StepGcXmit(n.rcvs_dormant.xmitAt(i));
  }
  public void StepGcXmit(Xmit x) throws Exception
  { XmitLocation loc=LocateXmit(x); loc.xmits.removeElement(x);
    if (x.sum!=null)
    { Sum sum=x.sum;
      if (sum.xmits.length==0) throw new Exception("found an empty sum!");
      else if (sum.xmits.length==1) throw new Exception("found a singleton sum!");
      else if (sum.xmits.length==2)
      { sum.xmits[0].sum=null; sum.xmits[1].sum=null; sums.removeElement(sum);
        if (sum.rep!=null)
        { Sum[] sums=new Sum[sum.rep.sums.length-1]; int n=0;
          for (int i=0; i<sum.rep.sums.length; i++) {if (sum.rep.sums[i]!=sum) {sums[n]=sum.rep.sums[i]; n++;}}
          sum.rep.sums=sums;
          StepGcCheckRep(sum.rep);
        }
      }
      else
      { Xmit[] xmits=new Xmit[sum.xmits.length-1]; int n=0;
        for (int i=0; i<sum.xmits.length; i++) {if (sum.xmits[i] != x) {xmits[n]=sum.xmits[i]; n++;}}
        sum.xmits=xmits;
      }
    }
    else if (x.rep!=null)
    { Xmit[] xmits=new Xmit[x.rep.xmits.length-1]; int n=0;
      for (int i=0; i<x.rep.xmits.length; i++) {if (x.rep.xmits[i]!=x) {xmits[n]=x.rep.xmits[i]; n++;}}
      x.rep.xmits=xmits;
      StepGcCheckRep(x.rep);
    }
    //
    for (int i=0; i<x.toenable.size(); i++) StepGcXmit(x.toenable.xmitAt(i));
  }
  // StepGcCheckRep -- after having removed a rep, or an xmit, or a sum, that
  // was pointed to by this rep, we check this rep to see if it still has useful
  // existence
  public void StepGcCheckRep(Rep r) throws Exception
  { if (r.xmits.length!=0 || r.sums.length!=0 || r.reps.length!=0) return;
    // If there are no xmits, sums or reps to be replicated, then it can be got rid of
    for (int i=0; i<r.res.length; i++) r.res[i].nref--;
    reps.removeElement(r);
    Rep repsrc=null; // we're looking for a parent for the rep now. repsrc is the parent
    for (int i=0; i<reps.size(); i++)
    { Rep rt=reps.repAt(i);
      for (int j=0; j<rt.reps.length; j++) if (rt.reps[j]==r) repsrc=rt;
    }
    if (repsrc==null) return; // no parent
    Rep[] reps=new Rep[repsrc.reps.length-1]; int n=0;
    for (int i=0; i<repsrc.reps.length; i++) {if (repsrc.reps[i]!=r) {reps[n]=repsrc.reps[i]; n++;}}
    repsrc.reps=reps;
    StepGcCheckRep(repsrc);
  }

  public void StepInteract(Xmit xout, Xmit xin, Name name) throws Exception
  { if (xout.dats.length!=xin.dats.length) throw new Exception("arity mismatch at name "+name.title);
    Rep rin=xin.rep;   if (xin.sum!=null) rin=xin.sum.rep;
    Rep rout=xout.rep; if (xout.sum!=null)rout=xout.sum.rep;
    if (rin!=null) StepRep(rin);
    if (rout!=null) StepRep(rout);
    // Those reps will have spawned off new copies. We will be left as we were,
    // with all our old pointers still where they were before, but no longer
    // pointing to any rep node.
    name.snds.removeElement(xout);
    name.rcvs.removeElement(xin);
    // StepFusion first reduces the nref count of both, and then adds one nref
    for (int i=0; i<xout.dats.length; i++) StepFusion(xout.dats[i],xin.dats[i]);
    for (int i=0; i<xout.fusions_src.length; i++) StepFusion(xout.fusions_src[i],xout.fusions_dst[i]);
    for (int i=0; i<xin.fusions_src.length; i++) StepFusion(xin.fusions_src[i],xin.fusions_dst[i]);
    StepActivate(xout.toenable);
    StepActivate(xin.toenable);
    if (xout.sum!=null) StepRemoveSum(xout.sum);
    if (xin.sum!=null) StepRemoveSum(xin.sum);
  }

  // The job of StepRep is to create an entirely new copy of the rep tree,
  // and detach the old thing from it.
  // Copy names, xmits, sums, reps.
  public void StepRep(Rep r) throws Exception
  { RNames n1=new RNames(); RNames n2=new RNames();
    RXmits x1=new RXmits(); RXmits x2=new RXmits();
    RSums  s1=new RSums();  RSums  s2=new RSums();
    RReps  r1=new RReps();  RReps  r2=new RReps();
    // We'll do it in two passes. First pass creates a new node for each of the old.
    // Second pass copies the data over, fixing up references.
    StepRep1R(r,n1,n2,x1,x2,s1,s2,r1,r2);
    StepRep2R(r,n1,n2,x1,x2,s1,s2,r1,r2);
    // That will actually have created a copy of this rep node. Fine. We'll
    // totally detach the old one.
    for (int i=0; i<r.reps.length; i++) {} // reps are already detached!
    for (int i=0; i<r.res.length; i++) {r.res[i].nref--;} 
    for (int i=0; i<r.sums.length; i++) r.sums[i].rep=null;
    for (int i=0; i<r.xmits.length; i++) r.xmits[i].rep=null;
    // and now insert them into the store.
    for (int i=0; i<n2.size(); i++) names.addElement(n2.nameAt(i));
    for (int i=0; i<s2.size(); i++) sums.addElement(s2.sumAt(i));
    for (int i=0; i<r2.size(); i++) reps.addElement(r2.repAt(i));
  }

  public void StepRep1R(Rep r,RNames n1,RNames n2,RXmits x1,RXmits x2,RSums s1,RSums s2,RReps r1,RReps r2)
  { r1.addElement(r); Rep rr=new Rep(); r2.addElement(rr);
    for (int i=0; i<r.res.length; i++)  StepRep1N(r.res[i],n1,n2,x1,x2,s1,s2,r1,r2);
    for (int i=0; i<r.reps.length; i++) StepRep1R(r.reps[i],n1,n2,x1,x2,s1,s2,r1,r2);
    for (int i=0; i<r.sums.length; i++) StepRep1S(r.sums[i],n1,n2,x1,x2,s1,s2,r1,r2);
    for (int i=0; i<r.xmits.length;i++) StepRep1X(r.xmits[i],n1,n2,x1,x2,s1,s2,r1,r2);
  }
  public void StepRep1N(Name n,RNames n1,RNames n2,RXmits x1,RXmits x2,RSums s1,RSums s2,RReps r1,RReps r2)
  { n1.addElement(n); Name nn=new Name(); n2.addElement(nn);
  }
  public void StepRep1S(Sum s,RNames n1,RNames n2,RXmits x1,RXmits x2,RSums s1,RSums s2,RReps r1,RReps r2)
  { s1.addElement(s); Sum ss=new Sum(); s2.addElement(ss);
    for (int i=0; i<s.xmits.length; i++) StepRep1X(s.xmits[i],n1,n2,x1,x2,s1,s2,r1,r2);
  }
  public void StepRep1X(Xmit x,RNames n1,RNames n2,RXmits x1,RXmits x2,RSums s1,RSums s2,RReps r1,RReps r2)
  { x1.addElement(x); Xmit xx=new Xmit(); x2.addElement(xx);
  }

  public void StepRep2R(Rep src,RNames n1,RNames n2,RXmits x1,RXmits x2,RSums s1,RSums s2,RReps r1,RReps r2)
  { Rep dst=StepRepFixR(src,r1,r2);
    dst.res=new Name[src.res.length];    for (int i=0; i<src.res.length;  i++) dst.res[i] =StepRepFixN(src.res[i],n1,n2);
    dst.reps=new Rep[src.reps.length];   for (int i=0; i<src.reps.length; i++) dst.reps[i]=StepRepFixR(src.reps[i],r1,r2);
    dst.sums=new Sum[src.sums.length];   for (int i=0; i<src.sums.length; i++) dst.sums[i]=StepRepFixS(src.sums[i],s1,s2);
    dst.xmits=new Xmit[src.xmits.length];for (int i=0; i<src.xmits.length;i++) dst.xmits[i]=StepRepFixX(src.xmits[i],x1,x2);
    for (int i=0; i<src.res.length; i++) StepRep2N(src.res[i],n1,n2,x1,x2,s1,s2,r1,r2);
    for (int i=0; i<src.reps.length; i++) StepRep2R(src.reps[i],n1,n2,x1,x2,s1,s2,r1,r2);
    for (int i=0; i<src.sums.length; i++) StepRep2S(src.sums[i],n1,n2,x1,x2,s1,s2,r1,r2);
    for (int i=0; i<src.xmits.length;i++) StepRep2X(src.xmits[i],n1,n2,x1,x2,s1,s2,r1,r2);
  }
  public void StepRep2N(Name src,RNames n1,RNames n2,RXmits x1,RXmits x2,RSums s1,RSums s2,RReps r1,RReps r2)
  { Name dst=StepRepFixN(src,n1,n2);
    dst.title=src.title;
    dst.fusion=StepRepFixN(src.fusion,n1,n2);
    dst.nref=src.nref;
    // and the appropriate snds/rcvs/snds_dormant/rcvs_dormant will already have been
    // put in, as part of the xmit processing
  }
  public void StepRep2S(Sum src,RNames n1,RNames n2,RXmits x1,RXmits x2,RSums s1,RSums s2,RReps r1,RReps r2)
  { Sum dst=StepRepFixS(src,s1,s2);
    dst.rep=StepRepFixR(src.rep,r1,r2);
    dst.xmits=new Xmit[src.xmits.length]; for (int i=0; i<src.xmits.length; i++) dst.xmits[i]=StepRepFixX(src.xmits[i],x1,x2);
    for (int i=0; i<src.xmits.length; i++) StepRep2X(src.xmits[i],n1,n2,x1,x2,s1,s2,r1,r2);
  }
  public void StepRep2X(Xmit src,RNames n1,RNames n2,RXmits x1,RXmits x2,RSums s1,RSums s2,RReps r1,RReps r2)
  { Xmit dst=StepRepFixX(src,x1,x2);
    dst.dats=new Name[src.dats.length]; for (int i=0; i<src.dats.length; i++) dst.dats[i]=StepRepFixN(src.dats[i],n1,n2);
    dst.fusions_src=new Name[src.fusions_src.length]; for (int i=0; i<src.fusions_src.length; i++) dst.fusions_src[i]=StepRepFixN(src.fusions_src[i],n1,n2);
    dst.fusions_dst=new Name[src.fusions_dst.length]; for (int i=0; i<src.fusions_dst.length; i++) dst.fusions_dst[i]=StepRepFixN(src.fusions_dst[i],n1,n2);
    dst.rep=StepRepFixR(src.rep,r1,r2);
    dst.sum=StepRepFixS(src.sum,s1,s2);
    XmitLocation loc=LocateXmit(src); Name nsrc=loc.n, ndst=StepRepFixN(nsrc,n1,n2);
    if (ndst==null) ndst=nsrc; // e.g. for !(\nux)u<x>, where we replicate an xmit not on the name
    if (loc.isactive) {if (loc.issnd) ndst.snds.addElement(dst); else ndst.rcvs.addElement(dst);}
    else {if (loc.issnd) ndst.snds_dormant.addElement(dst); else ndst.rcvs_dormant.addElement(dst);}
  }

  public Rep StepRepFixR(Rep r,RReps r1,RReps r2) {if (r==null) return null; int i=r1.indexOf(r); if (i==-1) return null; else return r2.repAt(i);}
  public Sum StepRepFixS(Sum s,RSums s1,RSums s2) {if (s==null) return null; int i=s1.indexOf(s); if (i==-1) return null; else return s2.sumAt(i);}
  public Name StepRepFixN(Name n,RNames n1,RNames n2) {if (n==null) return null; int i=n1.indexOf(n); if (i==-1) return null; else return n2.nameAt(i);}
  public Xmit StepRepFixX(Xmit x,RXmits x1,RXmits x2) {if (x==null) return null; int i=x1.indexOf(x); if (i==-1) return null; else return x2.xmitAt(i);}


  public void StepFusion(Name a,Name b) throws Exception
  { a.nref--; b.nref--;
    Name min,max;
    if (a.id<b.id) {min=a; max=b;} else {min=b; max=a;}
    min.fuseto(max);
  }

  public void StepActivate(Xmits xs) throws Exception
  { for (int i=0; i<xs.size(); i++)
    { Xmit xmit=xs.xmitAt(i);
      XmitLocation loc=LocateXmit(xmit);
      if (!loc.found) throw new Exception("Unable to find xmit to activate");
      if (loc.isactive) throw new Exception("xmit to activate was already active");
      loc.xmits.removeElement(xmit);
      if (loc.issnd) loc.n.snds.addElement(xmit); else loc.n.rcvs.addElement(xmit);
    }
  }

  public void StepRemoveSum(Sum sum) throws Exception
  { for (int i=0; i<sum.xmits.length; i++)
    { Xmit xmit=sum.xmits[i];
      XmitLocation loc=LocateXmit(xmit);
      if (!loc.found) throw new Exception("Unable to find xmit from sum to remove");
      if (!loc.isactive) throw new Exception("xmit from sum to remove was not active");
      loc.xmits.removeElement(xmit);
    }
  }

  // An EqStep - moving an atom, a free, a datum, or garbage collection
  public java.util.Vector EnumEqSteps()
  { java.util.Vector v=new java.util.Vector();
    for (int ni=0; ni<names.size(); ni++)
    { Name n=names.nameAt(ni);
      if (n.fusion!=null)
      { for (int xi=0; xi<n.snds.size(); xi++) v.addElement(new Step(n.snds.xmitAt(xi),n,n.fusion));
        for (int xi=0; xi<n.rcvs.size(); xi++) v.addElement(new Step(n.rcvs.xmitAt(xi),n,n.fusion));
        for (int xi=0; xi<n.snds_dormant.size(); xi++) v.addElement(new Step(n.snds_dormant.xmitAt(xi),n,n.fusion));
        for (int xi=0; xi<n.rcvs_dormant.size(); xi++) v.addElement(new Step(n.rcvs_dormant.xmitAt(xi),n,n.fusion));
      }
      boolean canreact = (n.snds.size()+n.snds_dormant.size()>0 && n.rcvs.size()+n.rcvs_dormant.size()>0);
      boolean hasatoms = (n.snds.size()>0 || n.rcvs.size()>0 || n.snds_dormant.size()>0 || n.rcvs_dormant.size()>0);
      if (n.nref==0 && !canreact && (n.fusion==null || !hasatoms)) v.addElement(new Step(n));
    }
    // We can move a free name down a fusion, but not onto something owned by a different free name
    for (int i=0; i<freen.length; i++)
    { if (freen[i].fusion!=null)
      { boolean isdestfree=false;
        for (int j=0; j<freen.length; j++) if (freen[i].fusion==freen[j]) isdestfree=true;
        if (!isdestfree) v.addElement(new Step(frees[i],i,freen[i],freen[i].fusion));
      }
    }
    for (int i=0; i<dats.length; i++)
    { if (dats[i].fusion!=null) v.addElement(new Step(i,dats[i],dats[i].fusion));
    }
    return v;
  }

  // An ExStep is the interaction of an in and an out.
  public java.util.Vector EnumExSteps()
  { java.util.Vector v=new java.util.Vector();
    for (int ni=0; ni<names.size(); ni++)
    { Name n=names.nameAt(ni);
      for (int si=0; si<n.snds.size(); si++)
      { for (int ri=0; ri<n.rcvs.size(); ri++)
        { v.addElement(new Step(n.snds.xmitAt(si),n.rcvs.xmitAt(ri),n));
        }
      }
    }
    return v;
  }


  public Model.State Play(Model.Operators ops) throws Exception
  { EnsureNamesUnique();
    // We will wrap everything up with a restriction on all names in the store
    // Within that:
    // dats, fusions, free->fusions are present. They'll go to the left
    // The rest is done recursively according to the tricky translation
    // We won't actually print local names that correspond to free ones.
    Model.State s=null;
    for (int i=0; i<names.size(); i++)
    { if (names.nameAt(i).fusion!=null)
      { String a=names.nameAt(i).title, b=names.nameAt(i).fusion.title;
        s=ops.ParAccumulate(s,ops.Fus(a,b));
      }
    }
    for (int i=0; i<dats.length; i++)
    { s=ops.ParAccumulate(s,ops.Dat(dats[i].title));
    }
    // Now the body
    Xmits acts=FindActives();
    Names stillbounds=new Names();
    for (int i=0; i<names.size(); i++) stillbounds.addElement(names.nameAt(i));
    Model.State s2=GatherXmits(acts,stillbounds,ops);
    s=ops.ParAccumulate(s,s2);
    // Now the restrictions. We won't show free->local names as restricted.
    for (int i=0; i<frees.length; i++) stillbounds.removeElement(freen[i]); 
    String[] rn=new String[stillbounds.size()];
    for (int i=0; i<stillbounds.size(); i++) rn[i]=stillbounds.nameAt(i).title;
    if (rn.length>0) s=ops.Res(rn,s);
    // and that's it!
    if (s==null) return ops.Nil(); else return s;
  }


  // GatherXmits -- gathers together the names listed.
  // Some will be in sums: gather them out and sum them
  // Some will be replicated (maybe even sums will be replicated); write
  //   !(nu x)(...) for the ones that go into each replication
  // Then, for each name, recursively find inside the things it activates
  public Model.State GatherXmits(Xmits act,Names stillbounds,Model.Operators ops) throws Exception
  { if (act==null || act.size()==0) return null;
    Sums sums=new Sums(); Xmits xmits=new Xmits(); Reps reps=new Reps();
    Xmits xmitsa=new Xmits(); Sums sumsa=new Sums();
    for (int i=0; i<act.size(); i++)
    { Xmit xmit=act.xmitAt(i);
      if (xmit.sum==null) xmitsa.addElement(xmit); else sumsa.unionElement(xmit.sum);
    }
    // Now xmitsa contains all the xmits, and sumsa contains all the sums.
    // We have to figure out if there are any reps
    Reps repsa=new Reps();
    for (int i=0; i<xmitsa.size(); i++)
    { Xmit xmit=xmitsa.xmitAt(i);
      if (xmit.rep==null) xmits.addElement(xmit); else repsa.unionElement(xmit.rep);
    }
    for (int i=0; i<sumsa.size(); i++)
    { Sum sum=sumsa.sumAt(i);
      if (sum.rep==null) sums.addElement(sum); else repsa.unionElement(sum.rep);
    }
    // Now reps contains all the reps, sums contains all sums not in a rep,
    // and xmits contains those xmits not in sums or reps
    // We're going to pull out so only the top level (not-nested) reps will appear
    for (int i=0; i<repsa.size(); i++) reps.addElement(repsa.repAt(i));
    for (int i=0; i<repsa.size(); i++)
    { Rep rep=repsa.repAt(i);
      for (int j=0; j<rep.reps.length; j++) reps.removeElement(rep.reps[j]);
    }
    // So here reps contains only the top level reps
    Model.State s=null;
    // (1) CONVERT THE XMITS
    for (int i=0; i<xmits.size(); i++)
    { Xmit xmit=xmits.xmitAt(i);
      Model.State s2=PlayXmit(xmit,stillbounds,ops);
      s=ops.ParAccumulate(s,s2);
    }
    // (2) CONVERT THE SUMS    
    for (int i=0; i<sums.size(); i++)
    { Sum sum=sums.sumAt(i);
      Model.State s2=PlaySum(sum,stillbounds,ops);
      s=ops.ParAccumulate(s,s2);
    }
    // (3) CONVERT THE REPS
    for (int i=0; i<reps.size(); i++)
    { Rep rep=reps.repAt(i);
      Model.State s2=PlayRep(rep,stillbounds,ops);
      s=ops.ParAccumulate(s,s2);
    }
    // and that's it!
    return s;
  } 


  // PlayXmit -- plays a particular xmit
  public Model.State PlayXmit(Xmit xmit,Names stillbounds,Model.Operators ops) throws Exception
  { Model.State s=null;
    for (int i=0; i<xmit.fusions_src.length; i++)
    { String a=xmit.fusions_src[i].title, b=xmit.fusions_dst[i].title;
      s=ops.ParAccumulate(s,ops.Fus(a,b));
    }
    for (int i=0; i<xmit.dats.length; i++)
    { s=ops.ParAccumulate(s,ops.Dat(xmit.dats[i].title));
    }
    Model.State sbody=GatherXmits(xmit.toenable,stillbounds,ops);
    s=ops.ParAccumulate(s,sbody);
    if (s==null) s=ops.Nil();
    //
    XmitLocation loc=LocateXmit(xmit);
    if (!loc.found) throw new Exception("Unable to find xmit to play");
    if (loc.issnd) s=ops.Snd(loc.n.title,s);
    else s=ops.Rcv(loc.n.title,s);
    //
    return s;
  }

  // PlaySum -- plays a particular sum
  public Model.State PlaySum(Sum sum,Names stillbounds,Model.Operators ops) throws Exception
  { Model.State s=null;
    for (int i=0; i<sum.xmits.length; i++)
    { Xmit xmit=sum.xmits[i];
      Model.State s2=PlayXmit(xmit,stillbounds,ops);
      s=ops.SumAccumulate(s,s2);
    }
    return s;
  }

  public Model.State PlayRep(Rep rep,Names stillbounds,Model.Operators ops) throws Exception
  { Model.State s=null;
    for (int i=0; i<rep.xmits.length; i++)
    { Xmit xmit=rep.xmits[i];
      Model.State s2=PlayXmit(xmit,stillbounds,ops);
      s=ops.ParAccumulate(s,s2);
    }
    for (int i=0; i<rep.sums.length; i++)
    { Sum sum=rep.sums[i];
      Model.State s2=PlaySum(sum,stillbounds,ops);
      s=ops.ParAccumulate(s,s2);
    }
    for (int i=0; i<rep.reps.length; i++)
    { Rep irep=rep.reps[i];
      Model.State s2=PlayRep(irep,stillbounds,ops);
      s=ops.ParAccumulate(s,s2);
    }
    // and now bind the names, and then replicate
    String[] rns=new String[rep.res.length]; for (int i=0; i<rep.res.length; i++) rns[i]=rep.res[i].title;
    if (rep.res.length>0) s=ops.Res(rns,s);
    for (int i=0; i<rep.res.length; i++) stillbounds.removeElement(rep.res[i]);
    s=ops.Rep(s);
    return s;
  }


 
  // LocateXmit -- find out where a particular xmit is
  public XmitLocation LocateXmit(Xmit x)
  { XmitLocation loc=new XmitLocation();
    for (int ni=0; ni<names.size(); ni++)
    { Name n=names.nameAt(ni);
      if (n.snds.contains(x)) {loc.found=true; loc.isactive=true; loc.issnd=true; loc.n=n; loc.xmits=n.snds; return loc;}
      if (n.rcvs.contains(x)) {loc.found=true; loc.isactive=true; loc.issnd=false;loc.n=n; loc.xmits=n.rcvs; return loc;}
      if (n.snds_dormant.contains(x)) {loc.found=true; loc.isactive=false; loc.issnd=true; loc.n=n; loc.xmits=n.snds_dormant; return loc;}
      if (n.rcvs_dormant.contains(x)) {loc.found=true; loc.isactive=false; loc.issnd=false;loc.n=n; loc.xmits=n.rcvs_dormant; return loc;}
    }
    loc.found=false; loc.n=null; loc.xmits=null; return loc;
  }

  // FindActives -- gathers a list of all xmits currently active 
  public Xmits FindActives()
  { Xmits acts=new Xmits();
    for (int ni=0; ni<names.size(); ni++)
    { Name n=names.nameAt(ni);
      for (int xi=0; xi<n.snds.size(); xi++) acts.addElement(n.snds.xmitAt(xi));
      for (int xi=0; xi<n.rcvs.size(); xi++) acts.addElement(n.rcvs.xmitAt(xi));
    }
    return acts;
  }


  // EnsureNamesUnique -- sticks as many dashes after each name as necessary
  // so that no local names clash, nor do they clash with the free ones.
  public void EnsureNamesUnique()
  { Strings useds=new Strings();
    for (int i=0; i<frees.length; i++) {freen[i].title=frees[i]; useds.addElement(frees[i]);}
    for (int ni=0; ni<names.size(); ni++)
    { Name n=names.nameAt(ni); if (n.title==null) n.title="z";
      boolean isfree=false;
      for (int i=0; i<frees.length; i++) if (freen[i]==n) isfree=true;
      if (!isfree)
      { while (useds.containsString(n.title)) n.title += "'";
      }
      useds.addElement(n.title);
    }
  }


  public synchronized void addStore(State n)
  { for (int i=0; i<n.names.size(); i++) names.addElement(n.names.elementAt(i));
    for (int i=0; i<n.reps.size(); i++) reps.addElement(n.reps.elementAt(i));
    for (int i=0; i<n.sums.size(); i++) sums.addElement(n.sums.elementAt(i));
  }

}



class Step
{ int type; 
  // 1=move-atom(x,n1,n2)
  // 2=gc(n)
  // 3=interact(x1,x2,n)
  // 4=move-free(str,i,n1,n2)
  // 5=move-dat(i,n1,n2)
  Xmit xmit1, xmit2;
  Name name1, name2;
  int i;
  public Step(Xmit x,Name n1,Name n2) {type=1; xmit1=x; xmit2=null; name1=n1; name2=n2;}
  public Step(Name n) {type=2; xmit1=null; xmit2=null; name1=n; name2=null;}
  public Step(Xmit x1,Xmit x2,Name n) {type=3; xmit1=x1; xmit2=x2; name1=n; name2=null;}
  public Step(String s,int index,Name n1,Name n2) {type=4; i=index; name1=n1; name2=n2;}
  public Step(int index,Name n1,Name n2) {type=5; i=index; name1=n1; name2=n2;}
}

class XmitLocation
{ Name n;
  boolean issnd;
  boolean isactive;
  boolean found;
  Xmits xmits;
}


class Strings extends java.util.Vector
{ public final synchronized String stringAt(int i)
  { return (String)elementAt(i);
  }
  public final synchronized boolean containsString(String s)
  { for (int i=0; i<size(); i++) {if (s.equals(stringAt(i))) return true;}
    return false;
  }
}

class RNames extends java.util.Vector
{ public final synchronized Name nameAt(int i) {return (Name)elementAt(i);}
  public RNames() {}
}
class RXmits extends java.util.Vector
{ public final synchronized Xmit xmitAt(int i) {return (Xmit)elementAt(i);}
  public RXmits() {}
}
class RSums extends java.util.Vector
{ public final synchronized Sum sumAt(int i) {return (Sum)elementAt(i);}
  public RSums() {}
}
class RReps extends java.util.Vector
{ public final synchronized Rep repAt(int i) {return (Rep)elementAt(i);}
  public RReps() {}
}

